
#property copyright "Copyright  2010.02.16, SwingMan"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Turquoise
#property indicator_color2 Fuchsia

extern bool Draw_Arrows = FALSE;
extern bool Draw_VerticalLines = TRUE;
extern bool Price_Filter25 = TRUE;
extern string ____Arrows____ = "";
extern int Arrow_UP = 233;
extern int Arrow_DN = 234;
extern string ____MACD____ = "";
extern int FastEMA = 12;
extern int SlowEMA = 26;
extern int Upper_Limit = 85;
extern int Lower_Limit = 15;
extern string ____RSI____ = "";
extern int Period_RSI = 5;
extern int Upper_Limit1 = 90;
extern int Upper_Limit2 = 70;
extern int Lower_Limit1 = 30;
extern int Lower_Limit2 = 10;
extern string ____Stochastic_1____ = "";
extern int K_Period1 = 7;
extern int Slowing1 = 3;
extern string ____Stochastic_2____ = "";
extern int K_Period2 = 14;
extern int Slowing2 = 5;
int g_period_188 = 3;
string gs_192 = "NB_Signal_";
double g_ibuf_200[];
double g_ibuf_204[];
double gda_208[];
double gda_unused_212[];
double gda_unused_216[];
double gda_unused_220[];
double gda_224[];
double gda_unused_228[];
double gda_unused_232[];
double gda_unused_236[];
double gda_240[];
double gda_unused_244[];
double gda_unused_248[];
double gda_unused_252[];
double gda_256[];
double gda_unused_260[];
double gda_unused_264[];
double gda_unused_268[];
double gda_272[];
double gda_276[];
double gd_280;
double gd_288;
double gd_296;
double gd_304;
double gd_312;
double gd_320;
int g_window_328;
string gs_332;
int gi_340;
int gi_344;
int gi_348;

int init() {
   ArraySetAsSeries(gda_208, TRUE);
   ArraySetAsSeries(gda_224, TRUE);
   ArraySetAsSeries(gda_240, TRUE);
   ArraySetAsSeries(gda_256, TRUE);
   ArraySetAsSeries(gda_272, TRUE);
   ArraySetAsSeries(gda_276, TRUE);
   SetIndexBuffer(0, g_ibuf_200);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, Arrow_UP);
   SetIndexLabel(0, NULL);
   SetIndexBuffer(1, g_ibuf_204);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, Arrow_DN);
   SetIndexLabel(1, NULL);
   gs_332 = "NB Meter_Signals";
   IndicatorShortName(gs_332);
   g_window_328 = 0;
   gi_344 = 13688896;
   gi_348 = 16711935;
   SetIndexDrawBegin(0, SlowEMA);
   SetIndexDrawBegin(1, SlowEMA);
   IndicatorDigits(Digits);
   gd_280 = 1.0 * Upper_Limit;
   gd_288 = 1.0 * Lower_Limit;
   gd_296 = 1.0 * Upper_Limit1;
   gd_304 = 1.0 * Lower_Limit1;
   gd_312 = 1.0 * Upper_Limit2;
   gd_320 = 1.0 * Lower_Limit2;
   return (0);
}

int deinit() {
   for (int l_count_0 = 0; l_count_0 < Bars; l_count_0++) Delete_VerticalLine(l_count_0);
   return (0);
}

int start() {
   int li_4;
   int li_28;
   int li_32;
   int li_36;
   int li_40;
   int li_44;
   ArrayResize(gda_208, Bars);
   ArrayResize(gda_224, Bars);
   ArrayResize(gda_240, Bars);
   ArrayResize(gda_256, Bars);
   ArrayResize(gda_272, Bars);
   ArrayResize(gda_276, Bars);
   int li_8 = IndicatorCounted();
   if (li_8 > 0) li_8--;
   gi_340 = Bars - li_8;
   for (int li_0 = 0; li_0 < gi_340; li_0++) {
      gda_208[li_0] = iMA(Symbol(), Period(), FastEMA, 0, MODE_EMA, PRICE_CLOSE, li_0) - iMA(Symbol(), Period(), SlowEMA, 0, MODE_EMA, PRICE_CLOSE, li_0);
      gda_224[li_0] = iRSI(Symbol(), Period(), Period_RSI, PRICE_WEIGHTED, li_0);
      gda_240[li_0] = iStochastic(Symbol(), Period(), K_Period1, g_period_188, Slowing1, MODE_LWMA, 1, MODE_MAIN, li_0);
      gda_256[li_0] = iStochastic(Symbol(), Period(), K_Period2, g_period_188, Slowing2, MODE_LWMA, 1, MODE_MAIN, li_0);
      gda_272[li_0] = High[li_0];
      gda_276[li_0] = Low[li_0];
   }
   int li_12 = WindowFirstVisibleBar();
   int li_16 = WindowBarsPerChart();
   int li_20 = li_12 - li_16;
   if (li_20 < 0) li_20 = 0;
   int li_24 = li_12 - li_20;
   for (li_0 = li_20; li_0 < li_12; li_0++) {
      li_28 = Get_MACD_Condition(li_0);
      li_32 = Get_RSI_Condition(li_0);
      li_36 = Get_Stoch_Condition(li_0, gda_240);
      li_40 = Get_Stoch_Condition(li_0, gda_256);
      if (Price_Filter25) li_44 = Get_Close_Condition(li_0);
      else li_44 = 1;
      li_4 = 0;
      if (li_28 == 1 && li_32 == 1 && li_36 == 1 && li_40 == 1 && li_44 == 1) li_4 = 1;
      else
         if (li_28 == -1 && li_32 == -1 && li_36 == -1 && li_40 == -1 && li_44 == -1) li_4 = -1;
      if (li_4 == 1) {
         if (Draw_Arrows) Draw_Arrow(li_0, li_4);
         if (Draw_VerticalLines) Draw_VerticalLine(li_0, gi_344);
      } else {
         if (li_4 == -1) {
            if (Draw_Arrows) Draw_Arrow(li_0, li_4);
            if (Draw_VerticalLines) Draw_VerticalLine(li_0, gi_348);
         } else {
            if (Draw_Arrows) Delete_Arrows(li_0);
            if (Draw_VerticalLines) Delete_VerticalLine(li_0);
         }
      }
   }
   return (0);
}

void Draw_Arrow(int ai_0, int ai_4) {
   double ld_8 = WindowPriceMax(0);
   double ld_16 = WindowPriceMin(0);
   double l_iatr_24 = iATR(Symbol(), Period(), 34, 1);
   double ld_32 = (ld_8 - ld_16) / 100.0 + l_iatr_24;
   if (ai_4 == 1) {
      g_ibuf_200[ai_0] = Low[ai_0] - ld_32;
      g_ibuf_204[ai_0] = EMPTY_VALUE;
      return;
   }
   if (ai_4 == -1) {
      g_ibuf_200[ai_0] = EMPTY_VALUE;
      g_ibuf_204[ai_0] = High[ai_0] + ld_32;
      return;
   }
   if (ai_4 == 0) {
      g_ibuf_200[ai_0] = EMPTY_VALUE;
      g_ibuf_204[ai_0] = EMPTY_VALUE;
   }
}

void Delete_Arrows(int ai_0) {
   g_ibuf_200[ai_0] = EMPTY_VALUE;
   g_ibuf_204[ai_0] = EMPTY_VALUE;
}

void Draw_VerticalLine(int ai_0, color a_color_4) {
   string l_name_8 = gs_192 + TimeToStr(Time[ai_0]);
   ObjectCreate(l_name_8, OBJ_VLINE, g_window_328, Time[ai_0], Close[ai_0]);
   ObjectSet(l_name_8, OBJPROP_COLOR, a_color_4);
}

void Delete_VerticalLine(int ai_0) {
   string l_name_4 = gs_192 + TimeToStr(Time[ai_0]);
   if (ObjectFind(l_name_4) != -1) ObjectDelete(l_name_4);
}

int Get_MACD_Condition(int ai_0) {
   double ld_4;
   int li_36 = WindowFirstVisibleBar();
   int li_40 = WindowBarsPerChart();
   int li_44 = li_36 - li_40;
   if (li_44 < 0) li_44 = 0;
   int li_48 = li_36 - li_44;
   double ld_12 = gda_208[ArrayMinimum(gda_208, li_48, li_44)];
   double ld_20 = gda_208[ArrayMaximum(gda_208, li_48, li_44)];
   double ld_28 = ld_20 - ld_12;
   if (ai_0 >= li_44 && ai_0 <= li_36) {
      if (ld_28 != 0.0) ld_4 = 100.0 * (gda_208[ai_0] - ld_12) / ld_28;
      ld_28 = ld_20 - ld_12;
      if (ld_28 != 0.0) ld_4 = 100.0 * (gda_208[ai_0] - ld_12) / ld_28;
      if (ld_4 > gd_280) return (-1);
      if (ld_4 < gd_288) return (1);
      return (0);
   }
   return (0);
}

int Get_Close_Condition(int ai_0) {
   int li_68 = WindowFirstVisibleBar();
   int li_72 = WindowBarsPerChart();
   int li_76 = li_68 - li_72;
   if (li_76 < 0) li_76 = 0;
   int li_80 = li_68 - li_76;
   double ld_44 = WindowPriceMin(0);
   double ld_52 = WindowPriceMax(0);
   double ld_60 = ld_52 - ld_44;
   double ld_20 = ld_60 / 4.0;
   double ld_28 = ld_52 - ld_20;
   double ld_36 = ld_44 + ld_20;
   double l_high_4 = High[ai_0];
   double l_low_12 = Low[ai_0];
   if (ai_0 >= li_76 && ai_0 <= li_68) {
      if (l_high_4 > ld_28) return (-1);
      if (l_low_12 < ld_36) return (1);
      return (0);
   }
   return (0);
}

int Get_RSI_Condition(int ai_0) {
   double ld_4 = gda_224[ai_0];
   if (ld_4 < gd_296 && ld_4 > gd_312) return (-1);
   if (ld_4 < gd_304 && ld_4 > gd_320) return (1);
   return (0);
}

int Get_Stoch_Condition(int ai_0, double ada_4[]) {
   double ld_8 = ada_4[ai_0];
   if (ld_8 > gd_280) return (-1);
   if (ld_8 < gd_288) return (1);
   return (0);
}